3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
12 # But we protect ourselves from such a user mistake nevertheless.
18 git_broken_path_fix () {
29 case "$SANE_TOOL_PATH:$elem" in
30 (?*:/bin | ?*:/usr/bin)
31 path="$path$sep$SANE_TOOL_PATH"
47 die_with_status 1 "$@"
60 if test -z "$GIT_QUIET"
66 if test -n "$OPTIONS_SPEC"; then
73 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
74 parseopt_extra="--keep-dashdash"
77 echo "$OPTIONS_SPEC" |
78 git rev-parse --parseopt $parseopt_extra -- "$@" ||
82 dashless=$(basename "$0" | sed -e 's/-/ /')
84 die "Usage: $dashless $USAGE"
87 if [ -z "$LONG_USAGE" ]
89 LONG_USAGE="Usage: $dashless $USAGE"
91 LONG_USAGE="Usage: $dashless $USAGE
103 set_reflog_action() {
104 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
106 GIT_REFLOG_ACTION="$*"
107 export GIT_REFLOG_ACTION
112 if test -z "${GIT_EDITOR:+set}"
114 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
117 eval "$GIT_EDITOR" '"$@"'
123 GIT_PAGER=$(git var GIT_PAGER)
130 eval "$GIT_PAGER" '"$@"'
134 GREP_OPTIONS= LC_ALL=C grep "$@"
138 GREP_OPTIONS= LC_ALL=C egrep "$@"
141 is_bare_repository () {
142 git rev-parse --is-bare-repository
146 cdup=$(git rev-parse --show-toplevel) &&
148 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
153 require_work_tree_exists () {
154 if test "z$(git rev-parse --is-bare-repository)" != zfalse
156 die "fatal: $0 cannot be used without a working tree."
160 require_work_tree () {
161 test "$(git rev-parse --is-inside-work-tree 2>/dev/null)" = true ||
162 die "fatal: $0 cannot be used without a working tree."
165 require_clean_work_tree () {
166 git rev-parse --verify HEAD >/dev/null || exit 1
167 git update-index -q --ignore-submodules --refresh
170 if ! git diff-files --quiet --ignore-submodules
172 echo >&2 "Cannot $1: You have unstaged changes."
176 if ! git diff-index --cached --quiet --ignore-submodules HEAD --
180 echo >&2 "Cannot $1: Your index contains uncommitted changes."
182 echo >&2 "Additionally, your index contains uncommitted changes."
189 test -n "$2" && echo >&2 "$2"
194 # Generate a sed script to parse identities from a commit.
196 # Reads the commit from stdin, which should be in raw format (e.g., from
197 # cat-file or "--pretty=raw").
199 # The first argument specifies the ident line to parse (e.g., "author"), and
200 # the second specifies the environment variable to put it in (e.g., "AUTHOR"
201 # for "GIT_AUTHOR_*"). Multiple pairs can be given to parse author and
203 pick_ident_script () {
212 s/^$lid "'\([^<]*\) <[^>]*> .*$/\1/'"
213 s/.*/GIT_${uid}_NAME='&'/p
216 s/^$lid "'[^<]* <\([^>]*\)> .*$/\1/'"
217 s/.*/GIT_${uid}_EMAIL='&'/p
220 s/^$lid "'[^<]* <[^>]*> \(.*\)$/@\1/'"
221 s/.*/GIT_${uid}_DATE='&'/p
228 # Create a pick-script as above and feed it to sed. Stdout is suitable for
230 parse_ident_from_commit () {
231 LANG=C LC_ALL=C sed -ne "$(pick_ident_script "$@")"
234 # Parse the author from a commit given as an argument. Stdout is suitable for
235 # feeding to eval to set the usual GIT_* ident variables.
236 get_author_ident_from_commit () {
237 encoding=$(git config i18n.commitencoding || echo UTF-8)
238 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
239 parse_ident_from_commit author AUTHOR
242 # Clear repo-local GIT_* environment variables. Useful when switching to
243 # another repository (e.g. when entering a submodule). See also the env
244 # list in git_connect()
245 clear_local_git_env() {
246 unset $(git rev-parse --local-env-vars)
250 # Platform specific tweaks to work around some commands
253 # Windows has its own (incompatible) sort and find
260 # git sees Windows-style pwd
264 is_absolute_path () {
273 is_absolute_path () {
282 # Make sure we are in a valid repository of a vintage we understand,
283 # if we require to be in a git repository.
284 if test -z "$NONGIT_OK"
286 GIT_DIR=$(git rev-parse --git-dir) || exit
287 if [ -z "$SUBDIRECTORY_OK" ]
289 test -z "$(git rev-parse --show-cdup)" || {
291 echo >&2 "You need to run this command from the toplevel of the working tree."
295 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
296 echo >&2 "Unable to determine absolute path of git directory"
299 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}